package org.seasar.quartz;

import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.SchedulerContext;
import org.quartz.SchedulerException;
import org.seasar.framework.container.S2Container;

public class DelegatingJobProxy implements Job {

    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
	SchedulerContext schedulerContext;
	try {
	    schedulerContext = jobExecutionContext.getScheduler().getContext();
	} catch (SchedulerException e) {
	    throw new JobExecutionException(e);
	}

	S2Container container = (S2Container) schedulerContext.get(QuartzConstants.CONTAINER);
	Object jobComponentKey = jobExecutionContext.getJobDetail().getJobDataMap().get(QuartzConstants.JOB_COMPONENT_KEY);
	Job jobComponent = (Job) container.getComponent(jobComponentKey);
	jobComponent.execute(jobExecutionContext);
    }
}
