package org.seasar.quartz;

import java.lang.reflect.Method;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.seasar.framework.util.ClassUtil;
import org.seasar.framework.util.MethodUtil;

public class MethodInvokingJob implements Job {

    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
	Object component = jobExecutionContext.getJobDetail().getJobDataMap().get(QuartzConstants.COMPONENT);
	String methodName = jobExecutionContext.getJobDetail().getJobDataMap().getString(QuartzConstants.METHOD_NAME);
	Method method = ClassUtil.getMethod(component.getClass(), methodName, null);
	MethodUtil.invoke(method, component, null);
    }
}
