package org.seasar.quartz;

import org.quartz.Scheduler;
import org.seasar.framework.container.ComponentDef;
import org.seasar.framework.container.MetaDef;
import org.seasar.framework.container.S2Container;

public class QuartzConfigurer {
    private int nextId = 0;

    public void init(Scheduler scheduler, S2Container container) throws Exception {
	scheduleJobs(scheduler, container.getRoot());
    }

    private void scheduleJobs(Scheduler scheduler, S2Container container) throws Exception {
	for (int i = 0; i < container.getComponentDefSize(); i++) {
	    ComponentDef componentDef = container.getComponentDef(i);
	    MetaDef[] metaDefs = componentDef.getMetaDefs("quartz:job");

	    for (int j = 0; j < metaDefs.length; j++) {
		MetaDef metaDef = metaDefs[j];

		MethodInvokingJobDetail methodInvokingJobDetail = new MethodInvokingJobDetail();
		methodInvokingJobDetail.setName("quartz:job:job-detail:" + ++nextId);
		methodInvokingJobDetail.setComponent(componentDef.getComponent());
		methodInvokingJobDetail.setMethodName((String) metaDef.getMetaDef("methodName").getValue());

		CronTrigger cronTrigger = new CronTrigger();
		cronTrigger.setName("quartz:job:trigger:" + nextId);
		cronTrigger.setCronExpression((String) metaDef.getMetaDef("cronExpression").getValue());

		scheduler.scheduleJob(methodInvokingJobDetail, cronTrigger);
	    }
	}

	for (int i = 0; i < container.getChildSize(); i++) {
	    scheduleJobs(scheduler, container.getChild(i));
	}
    }
}
